l = 0.72;    % [m] approximately
rb = 0.4;    % [m] approximately
rp = 0.2;    % [m] approximately
mb = 31.118; % [kg] approximately
mp = 5;      % [kg] approximately
taum = 1;    % [?] torque from DC-motor
g = 9.81;    % [m/s^2] gravity acceleration
I_b = 0;     % [Nm] Moment of Inertia of bicycle
I_p = 0;     % [Nm] Moment of Inertia of pendulum

% Friction Coefficients:
k_fb = 0; % Bicycle friction coefficient. In real life equal to zero 
k_fp = 0; % Pendulum motor friction coefficient. In real life very low, maybe neglect?

% l = 0.48;          % [m] approximately
% rb = 0.1756;       % [m] approximately
% rp = 0.0824704;    % [m] approximately
% mb = 0.516;        % [kg] approximately
% mp = 3.247;        % [kg] approximately
% g = 9.81;          % [m/s^2] gravity acceleration
% I_b = 0.02464;      % [Nm] Moment of Inertia of bicycle
% I_p = 0.09393;      % [Nm] Moment of Inertia of pendulum
% 
% % Friction Coefficients:
% k_fb = 0.06391; % Bicycle friction coefficient. In real life equal to zero 
% k_fp = 0.2446; % Pendulum motor friction coefficient. In real life very low, maybe neglect?

% Linear Model around the unstable sadle equilibrium thetab = thetap = 0

M = [mb*rb^2+mp*(l^2+rp^2+2*rp*l) mp*rp*(l+rp);
     mp*rp*(l+rp)                  mp*rp^2    ];
    
C = zeros(2,2);

F = [0; 1];

dGdq = [-g*(mb*rb+mp*rp+mp*l) -mp*rp*g;
        -mp*rp*g              -mp*rp*g]; 
    
A = [zeros(2,2)     eye(2);
     -inv(M)*dGdq -inv(M)*C];

B = [zeros(2,1);
     inv(M)*F ];
 
%C = eye(4); % Must have eye(4), else P is inf.

C = [1 0 0 0;
     0 1 0 0];

CO = ctrb(A,B);
OB = obsv(A,sqrt(C));

s = tf('s');
G = C*inv((s*eye(4)-A))*B;

% Choosing wighted matrices Q and R:

%Q = C'*C;
Q = 0.1*[1 0 0 0;0 1 0 0; 0 0 1 0; 0 0 0 1];
% Q = [1000 500  0     0;
%      500 1000  0     0;
%        0    0  1000 500;
%        0    0  500 1000];

% R_weight = 1e4;
R_weight = 1;
R = R_weight*eye(1);


[K,P,EIG] = lqr(A,B,Q,R);
%K1 = inv(R)*B'*P;

%Potential Energy, U:
U = (mb*rb+mp*l)*g+mp*rp*g;

% Symmetric pos. def. soln of the algebraic Riccati equation: P

%P = inv(C*inv(B*K-A)*B);

%----------Simulation Run Time-----------

t0 = 0;      %start
tn = 20;     %end