l = 0.72;    % [m] approximately
rb = 0.4;    % [m] approximately
rp = 0.2;    % [m] approximately
mb = 31.118; % [kg] approximately
mp = 5;      % [kg] approximately
taum = 1;    % [?] torque from DC-motor
g = 9.81;    % [m/s^2] gravity acceleration
I_b = 0;     % [Nm] Moment of Inertia of bicycle
I_p = 0;     % [Nm] Moment of Inertia of pendulum

% Friction Coefficients:
k_fb = 0; % Bicycle friction coefficient. In real life equal to zero 
k_fp = 0; % Pendulum motor friction coefficient. In real life very low, maybe neglect?

% System matrices for linearized state space model
M = [mb*rb^2+mp*(l^2+rp^2+2*rp*l) mp*rp*(l+rp);
     mp*rp*(l+rp)                  mp*rp^2    ];
    
C = zeros(2,2);

F = [0; 1];

dGdq = [-g*(mb*rb+mp*rp+mp*l) -mp*rp*g;
        -mp*rp*g              -mp*rp*g]; 
    
A = [zeros(2,2)     eye(2);
     -inv(M)*dGdq -inv(M)*C];

B = [zeros(2,1);
     inv(M)*F ];

% System matrices for linearized Partially Feedback Linearized system 
% A = [0 0 1 0;
%      0 0 0 1;
%     g*(mb*rb+mp*rp+mp*l)/(mb*rb^2+mp*rp^2+mp*l^2+2*mp*rp*l) mp*rp*g/(mb*rb^2+mp*rp^2+mp*l^2+2*mp*rp*l) 0 0;
%     0 0 0 0];
%  
% B = [0;
%      0;
%      -(mp*rp^2+mp*rp*l)/(mb*rb^2+mp*rp^2+mp*l^2+2*mp*rp*l);
%      1];
%  
 

C = [1 0 0 0;
     0 1 0 0];

CO = ctrb(A,B);
OB = obsv(A,sqrt(C));

% Choosing wighted matrices Q and R:
% Q = 1000*[1 0 0 0;0 1 0 0; 0 0 1 0; 0 0 0 1];
Q = 0.1*[1 0 0 0;0 1 0 0; 0 0 1 0; 0 0 0 1];

% R_weight = 1e4;
R_weight = 1;
R = R_weight*eye(1);


[K,P,EIG] = lqr(A,B,Q,R);
%K1 = inv(R)*B'*P;

%Potential Energy, U:
U = (mb*rb+mp*l)*g+mp*rp*g;

% Symmetric pos. def. soln of the algebraic Riccati equation: P

%P = inv(C*inv(B*K-A)*B);
